import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:hub/shared/helpers/storage/base_storage.dart';
import 'package:hub/shared/helpers/storage/storage_helper.dart';

import 'index.dart';

class HomeBloc extends Bloc<HomeEvent, HomeState> {
  HomeBloc() : super(HomeState()) {
    on<HomeEvent>((event, emit) async {
      final devUUID = (await StorageHelper().g(KeychainStorageKey.devUUID.value)) ?? '';
      final userUUID = (await StorageHelper().g(KeychainStorageKey.userUUID.value)) ?? '';
      final cliUUID = (await StorageHelper().g(KeychainStorageKey.clientUUID.value)) ?? '';
      final userName = (await StorageHelper().g(KeychainStorageKey.userName.value)) ?? '';
      final userEmail = (await StorageHelper().g(SecureStorageKey.email.value)) ?? '';

      emit(state.copyWith(
        devUUID: devUUID,
        userUUID: userUUID,
        cliUUID: cliUUID,
        userName: userName,
        userEmail: userEmail,
      ));
    });
  }
}
